article/urls.py
from django.urls import path
from . import views

app_name = 'article'

urlpatterns = [
    # 文章详情
    path('article-detail/<int:id>/', views.article_detail, name='article_detail'),
    # 文章创建
    path('article-create/', views.article_create, name='article_create'),
    # 文章更新
    path('article-update/<int:id>/', views.article_update, name='article_update'),
    # 文章删除
    path('article-delete/<int:id>/', views.article_delete, name='article_delete'),
    # 文章附件下载
    path('article-download/<int:id>', views.download_file, name='download_file'),
]

like/urls.py
from django.urls import path
from . import views

app_name = 'like'

urlpatterns = [
    path('like-change/', views.like_change, name='like_change'),
]

question/urls.py
from django.urls import path
from . import views

app_name = 'question'

urlpatterns = [

    # 文章详情
    path('question-detail/<int:id>/', views.question_detail, name='question_detail'),
    path('question-create/', views.question_create, name='question_create'),
    path('question-update/<int:id>/', views.question_update, name='question_update'),
    path('question-delete/<int:id>/', views.question_delete, name='question_delete'),
    path('question-download/<int:id>', views.download_file, name='download_file'),
]

sailing/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import render
from article import views as article_views
from question import views as question_views
from userprofile import views as user_views

from django.conf import settings
from django.conf.urls.static import static
from itertools import chain
import notifications.urls
def mainPage(request):
    return render(request, 'userprofile/collection.html', {})

def sort_column(column_questions, column_articles):
    column_content = []

    for question in column_questions:
        content = {'title': question.title, 'id': question.id, 'column': str(question.column), 'updated': question.updated, 'type': 'question'}
        column_content.append(content)
        pass

    for article in column_articles:
        content = {'title': article.title, 'id': article.id, 'column': str(article.column), 'updated': article.updated, 'type': 'article'}
        column_content.append(content)
        pass

    column_content = sorted(column_content, key=lambda x:(x['column'], x['updated']), reverse = True)
    
    #for item in column_content:
    #    if item['column'] != 'None':
    #        print(item)
    return column_content

def hot_content(request):
    # hotContent
    hot_questions = question_views.hot_question_list(request)
    hot_articles = article_views.hot_article_list(request)
    # blockContent
    column_questions = question_views.column_question_list()
    column_articles = article_views.column_article_list()
    column_content = sort_column(column_questions["column_questions"], column_articles["column_articles"])
    column_content = {'column_content': column_content}

    context = {**hot_questions, **hot_articles, **column_content}
    return render(request, 'mainPage.html', context)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('userprofile/', include('userprofile.urls', namespace='userprofile')),
    path('article/', include('article.urls', namespace='article')),
    path('question/', include('question.urls', namespace='question')),
    path('comment/', include('comment.urls', namespace='comment')),
    path('answer/', include('answer.urls', namespace='answer')),
    path('like/', include('like.urls', namespace='like')),
    path('', hot_content, name='hot_content'),
    path('collect/', include('collect.urls', namespace='collect')),
    path('search_question/', question_views.search_question),
    path('search_article/', article_views.search_article),
    path('search_user/', user_views.search_user),
    path('blocks/',include('blocks.urls', namespace='blocks')),
    path('inbox/notifications/', include(notifications.urls, namespace='notifications')),
    path('notice/', include('notice.urls', namespace='notice')),
    # path('', mainPage)
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

userprofile/urls.py
from django.urls import path
from . import views

app_name = 'userprofile'

urlpatterns = [
    # 用户登入
    path('login/', views.user_login, name='login'),
    # 用户退出
    path('logout/', views.user_logout, name='logout'),
    # 用户退出
    path('register/', views.user_register, name='register'),
    # 用户删除
    path('delete/<int:id>/', views.user_delete, name='delete'),
    # 用户查看信息
    path('profile/<int:id>/', views.profile, name='profile'),
    # 用户编辑信息
    path('profile-update/<int:id>/', views.profile_update, name='profile_update'),
    # 用户修改密码
    path('password-update/<int:id>/', views.password_update, name='password_update'),
    # 用户查看收藏记录
    path('collect-record/<int:id>/', views.get_collect_record, name='get_collect_record'),
    # 用户封禁
    path('user-forbidden/<int:id>/', views.user_forbidden, name='user_forbidden'),
    #查看用户发表的东西
    path('user-get_myob/<int:id>/', views.get_myob, name='user_get_myob'),
]

userprofile/models.py
from django.db import models

# Create your models here.
from django.db import models
from django.contrib.auth.models import User
# 引入内置信号
from django.db.models.signals import post_save
# 引入信号接收器的装饰器
from django.dispatch import receiver



class Profile(models.Model):
    """用户信息

    每个用户都与django自带的基本用户信息有级联关系

    属性：
        user     ：django自带的用户类信息，包含姓名、密码等
        phone    ：用户的电话号码
        avatar   ：用户的头像，按照上传年月日保存至avatar文件路径中
        bio      ：用户的个人简介
        email    ：用户的邮箱
    """
    user = models.OneToOneField(User, on_delete=models.CASCADE, related_name='profile')
    phone = models.CharField(max_length=20, blank=True)
    avatar = models.ImageField(upload_to='avatar/%Y%m%d/', blank=True)
    bio = models.TextField(max_length=500, blank=True)
    email = models.CharField(max_length=20, blank=True)

    def __str__(self):
        return 'user {}'.format(self.user.username)

userprofile/forms.py
# 引入表单类
from django import forms
# 引入django自带的User数据模型
from django.contrib.auth.models import User
from .models import Profile


# 登录需要用到的表单
class UserLoginForm(forms.Form):
    username = forms.CharField()
    password = forms.CharField()


# 注册需要用到的表单
class UserRegisterForm(forms.ModelForm):
    # 复写 User 的密码
    password = forms.CharField()
    password2 = forms.CharField()

    # 定义数据，使用django的user类
    class Meta:
        model = User
        fields = ('username', 'email')

    # 对两次输入的密码是否一致进行检查
    def clean_password2(self):
        data = self.cleaned_data
        if data.get('password') == data.get('password2'):
            return data.get('password')
        else:
            raise forms.ValidationError("密码输入不一致,请重试。")


# 修改用户信息需要用到的表单
class UserProfileForm(forms.ModelForm):
    class Meta:
        model = Profile
        fields = ('phone', 'avatar', 'bio', 'email' )


# 修改用户密码需要用到的表单
class UserPasswordForm(forms.Form):
    old_password = forms.CharField()
    new_password = forms.CharField()
    new_password2 = forms.CharField()

userprofile/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth import authenticate, login , logout
from django.http import HttpResponse
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required
from django.contrib import messages
from django.db.models import Q
from django.contrib.auth.hashers import check_password
from django.contrib.contenttypes.models import ContentType
from .models import Profile
from .forms import UserLoginForm , UserRegisterForm, UserProfileForm, UserPasswordForm
from like.models import LikeRecord
from collect.models import CollectRecord
from article.models import ArticlePost
from question.models import QuestionPost
from comment.models import Comment
from answer.models import Answer
# 引入分页模块
from django.core.paginator import Paginator
# 引入权限检查模块
from django.contrib.auth.models import User
from django.contrib.auth.models import Permission

# 函数名：  search_user
# 作者：    tyt
# 日期：    2020-7-22
# 功能：    根据前端获得的search值进行对用户的搜索
# 输入参数：request Django前端传来的请求
# 返回值：  类型（JsonResponse）
#          'request'  : 前端请求类型
#          'users'    : 搜索到的用户
#          'search_u' : 前端输入的搜索内容
#          'search/search_user.html' : 用户搜索界面
# 修改记录：
def search_user(request):
    # 判断是否进行了搜索
    search = request.GET.get('search')
    # 如果进行了搜索
    if search:
        users = User.objects.filter(
            # 匹配用户名(不区分大小写)
            Q(username__icontains=search)
        )
        context = {'users': users, 'search_u': search}
    # 如果未进行搜索
    else:
        context = {'users': [], 'search_u': search}
    return render(request, 'search/search_user.html', context)

# 函数名：  user_login
# 作者：    tyt
# 日期：    2020-7-22
# 功能：    根据前端获得的用户登录表格信息，进行登录处理操作（包含密码检查）
# 输入参数：request Django前端传来的请求
# 返回值：  类型（JsonResponse）
#          'request'  : 前端请求类型
#          'form'     : 用户登录所需要的信息表格
#          '/'        : 登陆成功返回主页    
#          'userprofile/login.html' : 用户登录界面
# 修改记录：
def user_login(request):
    # 用户进行数据POST
    if request.method == 'POST':
        # 得到用户的数据
        user_login_form = UserLoginForm(data=request.POST)
        # 判断数据是否有效
        if user_login_form.is_valid():
            # 清洗出合法数据
            data = user_login_form.cleaned_data
            # 检验账号、密码是否正确匹配数据库中的某个用户
            # 如果均匹配则返回这个 user 对象
            user = authenticate(username=data['username'], password=data['password'])
            if user:
                # 将用户数据保存在 session 中，即实现了登录动作
                login(request, user)
                # 返回主页链接
                return redirect("/")
            else:
                # 创建用户表单类
                user_login_form = UserLoginForm()
                # 赋予上下文
                context = {'form': user_login_form}
                messages.success(request, "账号或密码输入不合法")
                return render(request, 'userprofile/login.html', context)
        else:
            # 创建用户表单类
            user_login_form = UserLoginForm()
            # 赋予上下文
            context = {'form': user_login_form}
            messages.success(request, "账号或密码输入不合法")
            return render(request, 'userprofile/login.html', context)
    # 用户获取视图
    elif request.method == 'GET':
        # 创建用户表单类
        user_login_form = UserLoginForm()
        # 赋予上下文
        context = { 'form': user_login_form }
        # 返回呈现给登录页面
        return render(request, 'userprofile/login.html', context)
    # 危险情况
    else:
        # 创建用户表单类
        user_login_form = UserLoginForm()
        # 赋予上下文
        context = {'form': user_login_form}
        messages.success(request, "请使用GET或POST请求数据")
        return render(request, 'userprofile/login.html', context)

# 函数名：  user_logout
# 作者：    tyt
# 日期：    2020-7-22
# 功能：    将以登录的用户执行登出操作
# 输入参数：request Django前端传来的请求
# 返回值：  redirect函数
#          '/'  : 临时重定向到主页
# 修改记录：
def user_logout(request):
    # 用户登出
    logout(request)
    # 返回首页
    return redirect("/")

# 函数名：  user_register
# 作者：    tyt
# 日期：    2020-7-22
# 功能：    根据前端获得的用户注册表格信息，进行注册录处理操作（包含密码检查，用户权限授予）
# 输入参数：request Django前端传来的请求
# 返回值：  类型（JsonResponse）
#          'request'  : 前端请求类型
#          'form'     : 用户注册所需要的信息表格
#          '/'        : 登陆成功返回主页    
#          'userprofile/register.html' : 用户注册界面
# 修改记录：
def user_register(request):
    # 用户进行数据POST
    if request.method == 'POST':
        # 得到注册表单数据
        user_register_form = UserRegisterForm(data=request.POST)
        # 检测数据是否有效
        if user_register_form.is_valid():
            # 保存表单到暂存区
            new_user = user_register_form.save(commit=False)
            # 设置密码
            new_user.set_password(user_register_form.cleaned_data['password'])
            # 保存用户名密码到数据库
            new_user.save()
            # 保存好数据后立即登录
            login(request, new_user)
            # 赋予新用户权限
            user_authorization(new_user.id)
            # 返回主界面
            return redirect("/")
        else:
            # 获取注册表格初始化
            user_register_form = UserRegisterForm()
            # 联系上下文
            context = {'form': user_register_form}
            messages.success(request, "注册表单有误，请重新输入~")
            # 传输到模板呈现给用户
            return render(request, 'userprofile/register.html', context)
    # 用户进行表格页面请求
    elif request.method == 'GET':
        # 获取注册表格初始化
        user_register_form = UserRegisterForm()
        # 联系上下文
        context = { 'form': user_register_form }
        # 传输到模板呈现给用户
        return render(request, 'userprofile/register.html', context)
    else:
        # 获取注册表格初始化
        user_register_form = UserRegisterForm()
        # 联系上下文
        context = {'form': user_register_form}
        messages.success(request, "请使用GET或POST请求数据")
        # 传输到模板呈现给用户
        return render(request, 'userprofile/register.html', context)


# 函数名：  user_delete
# 作者：    tyt
# 日期：    2020-7-22
# 功能：    对已登录的用户进行删除操作
# 输入参数：request Django前端传来的请求
#          id : 用户的id
# 返回值：  redirect函数、HttpResponse网站回执
#          '/'  : 临时重定向到主页
# 修改记录：
@login_required(login_url='/userprofile/login/')
def user_delete(request, id):
    # 得到用户id
    user = User.objects.get(id=id)
    # 验证登录用户、待删除用户是否相同
    if request.user == user:
        # 退出登录
        logout(request)
        # 删除数据
        user.delete()
        # 返回主界面
        return redirect("/")
    else:
        return HttpResponse("你没有删除操作的权限。")

# 函数名：  profile
# 作者：    tyt
# 日期：    2020-7-22
# 功能：    查看用户个人信息界面，将个人信息返回至前端
# 输入参数：request Django前端传来的请求
#          id : 用户的id
# 返回值：  类型（JsonResponse）
#          'request'  : 前端请求类型
#          'profile'  : 用户简历中的扩展信息
#          'user'     : 用户的基本信息
#          'userprofile/personaldetail.html' : 用户的个人信息界面
# 修改记录：
@login_required(login_url='/userprofile/login/')
def profile(request, id):
    user = User.objects.get(id=id)
    if Profile.objects.filter(user_id=id).exists():
        profile = Profile.objects.get(user_id=id)
    else:
        profile = Profile.objects.create(user=user)

    context = {'profile': profile, 'user': user}
    return render(request, 'userprofile/personaldetail.html',context)

# 函数名：  profile_update
# 作者：    tyt
# 日期：    2020-7-22
# 功能：    更新用户的个人信息
# 输入参数：request Django前端传来的请求
#          id : 用户的id
# 返回值：  类型（JsonResponse）、redirect函数、HttpResponse网站回执
#          'request'      : 前端请求类型
#          'profile_form' : 用户编辑个人信息所需要的信息表格
#          'profile'      : 用户简历中的扩展信息
#          'user'         : 用户的基本信息
#          'id'           : 用户的id
#          'userprofile:profile'      : 重定向到用户的个人信息编辑界面
#          'userprofile/profile.html' : 用户的个人信息编辑界面
# 修改记录：
@login_required(login_url='/userprofile/login/')
def profile_update(request, id):
    user = User.objects.get(id=id)
    # user_id 是 OneToOneField 自动生成的字段
    if Profile.objects.filter(user_id=id).exists():
        profile = Profile.objects.get(user_id=id)
    else:
        profile = Profile.objects.create(user=user)

    if request.method == 'POST':
        # 验证修改数据者，是否为用户本人
        if request.user != user:
            return HttpResponse("你没有权限修改此用户信息。")

        profile_form = UserProfileForm(request.POST,request.FILES)
        if profile_form.is_valid():
            # 取得清洗后的合法数据
            profile_cd = profile_form.cleaned_data
            profile.phone = profile_cd['phone']
            profile.bio = profile_cd['bio']
            profile.email = profile_cd['email']
            user.email = profile_cd['email']
            if 'avatar' in request.FILES:
                profile.avatar=profile_cd['avatar']
            user.save()
            profile.save()
            # 带参数的 redirect()
            return redirect("userprofile:profile", id=id)
        else:
            return HttpResponse("注册表单输入有误。请重新输入~")

    elif request.method == 'GET':
        profile_form = UserProfileForm()
        context = {'profile_form': profile_form, 'profile': profile, 'user': user}
        return render(request, 'userprofile/profile.html', context)
    else:
        return HttpResponse("请使用GET或POST请求数据")

# 函数名：  password_update
# 作者：    tyt
# 日期：    2020-7-22
# 功能：    更改用户的密码
# 输入参数：request Django前端传来的请求
#          id : 用户的id
# 返回值：  类型（JsonResponse）、redirect函数
#          'request'            : 前端请求类型
#          'user_password_form' : 用户更改个人密码所需要的信息表格
#          '/'                  : 临时重定向到主页
#          'userprofile/setting.html' : 用户更改密码界面
# 修改记录：
@login_required(login_url='/userprofile/login/')
def password_update(request, id):
    user = get_object_or_404(User, id=id)

    if request.method == "POST":
        user_password_form = UserPasswordForm(request.POST)

        if user_password_form.is_valid():
            old_password = user_password_form.cleaned_data['old_password']
            new_password = user_password_form.cleaned_data['new_password']
            new_password2 = user_password_form.cleaned_data['new_password2']

            if not check_password(old_password, user.password):
                messages.error(request, "原始密码输入错误！")
                return render(request, 'userprofile/setting.html', {'user_password_form': user_password_form})

templates/userprofile/collection.html
{% extends "base.html" %}
{% load staticfiles %}
{% load like_tags %}
{% load collect_tags %}

{% block title %}
    我的收藏
{% endblock title %}

{% block content %}
<div class="text-center mt-4">
    <h4><b>我的收藏</b></h4>
</div>

<!-- 
片段名称：  搜索框
作者:	    ny
时间：	    2020-8-2
功能：	    在搜索框中输入内容，搜索收藏的内容
修改记录： 
--> 
<div class="container">
        <div class="d-flex justify-content-center mt-4">
            <form class="form-inline" >

                <label for="search" class="mr-4">搜索</label>
                <input type="text"
                    class="form-control mb-2 mr-sm-2"
                       id="search"
                    name="search"
                    placeholder="搜索..."
                    required
                >
            </form>
        </div>
</div>
<!-- 
片段名称：  收藏结果
作者:	    ny
时间：	    2020-8-2
功能：	    在搜索框中输入内容，搜索收藏的内容
			点击，可以通过链接进入
修改记录： 
--> 
<div class="container ml-4">
	{% if search %}
        {% if collections %}
            <h4><span style="color: cadetblue">"{{ search }}"</span>的搜索结果如下：</h4>
            <hr>
        {% else %}
            <h4>暂无<span style="color: cadetblue">"{{ search }}"</span>有关的收藏。</h4>
            <hr>
        {% endif %}
	<HR>
	{% endif %}

	{% if len %}
	<p>收藏数：{{len}}</p>

	{% for collection in collections %}
	<HR>
	<div><!--回答1-->
		{% if collection.content_type == 'answer' or collection.content_type == 'comment'%}
			<span>
                    <i class="fas fa-user" style="color:yellowgreen"></i>
                    {{ collection.object.user }}
                </span>
		{% else %}
		<span>
                    <i class="fas fa-user" style="color:yellowgreen"></i>
                    {{ collection.object.author }}
                </span>
		{% endif %}


		{% if collection.content_type == 'articlepost' %}
        	<p><a href="{% url 'article:article_detail' collection.object.id %}">{{collection.object.title}}</a></p>
		{% elif collection.content_type == 'questionpost' %}
        	<p><a href="{% url 'question:question_detail' collection.object.id %}">{{collection.object.title}}</a></p>
		{% elif collection.content_type == 'answer' %}
			<p><a href="{% url 'question:question_detail' collection.object.question.id %}">回答：{{collection.object.body|slice:'100'}}</a></p>
		{% elif collection.content_type == 'comment' %}
			<p><a href="{% url 'article:article_detail' collection.object.article.id %}">评论：{{collection.object.body|slice:'100'}}</a></p>
		{% endif %}

		<p>
			<span class="mr-2"><i id="like-icon" class="fas fa-heart" style="color:pink;"></i>{% get_likes_num collection.object %}</span>
			<span class="mr-2"><i id="collect-icon" class="fas fa-paper-plane" style="color:cadetblue;"></i>{% get_collect_num collection.object %}</span>
			{% if collection.object.updated %}
			<span class="mr-2">
                    <i class="fas fa-clock" style="color:gray;"></i>
                    {{collection.object.updated|date:'Y-m-d' }}
                </span>
			{% else %}
			<span class="mr-2">
                    <i class="fas fa-clock" style="color:gray;"></i>
                    {{collection.object.created|date:'Y-m-d' }}
                </span>
			{% endif %}</p>
	</div>
	{% endfor %}
	{% else %}
	{% if not search %}
	<h5>还没有收藏哦，快去添加收藏吧~</h5>
	{% endif %}
	{% endif %}
</div>
{% endblock content %}

templates/userprofile/login.html
{% extends "base.html" %}
{% load staticfiles %}
{% block title %} 登录 {% endblock title %}
{% block content %}
<!-- 
片段名称：  登入界面
作者:	    ssc
时间：	    2020-8-2
功能：	    用户的登入界面
            输入账号，密码，可以登入
            未注册用户可以进入注册界面
            若输入错误，会弹框提示输入错误
            若输入正确，可以直接登录
修改记录： 
--> 
<div class="container">
        <div class="d-flex mt-5 justify-content-center">
            <br>
            <form method="post" action=".">
                {% csrf_token %}
                <!-- 账号 -->
                <div class="form-group">
                    <label for="username">账号</label>
                    <input type="text" class="form-control" id="username" name="username">
                </div>
                <!-- 密码 -->
                <div class="form-group">
                    <label for="password">密码</label>
                    <input type="password" class="form-control" id="password" name="password">
                </div>
                <!-- 提交按钮 -->
                <button type="submit" class="btn btn-primary">提交</button>
                <!-- 注册 -->
                <div class="col-12">
                    <br>
                    <h5>点击<a href='{% url "userprofile:register" %}'>注册</a></h5>
                    <br>
                </div>
            </form>
        </div>
</div>
{% if messages %}
        <script>
            {% for msg in messages %}
                alert('{{ msg.message }}');
            {% endfor %}
        </script>
{% endif %}
{% endblock content %}

templates/userprofile/myob.html
<!-- extends表明此页面继承自 base.html 文件 -->
{% extends "base.html" %}
{% load static %}



<!-- 写入 base.html 中定义的 title -->
{% block title %}

{{ this_user.username }}的空间

{% endblock title %}

<!-- 写入 base.html 中定义的 content -->
{% block content %}
<div class="text-center mt-4">
    <h4><b>{{ this_user.username }}的空间</b></h4>
</div>
<!-- 
片段名称：  显示我发布的问题文章
作者:	    ssc
时间：	    2020-8-2
功能：	    显示发布的问题，文章
            板块通过特定颜色标识
            显示摘要前面一段字符
修改记录： 
--> 
<!-- 定义放置文章标题的div容器 -->
<div class="container">
    <div class="row mt-2">
        {% for ob in column_content %}
        <!-- 文章内容 -->
        <div class="col-12">
            <!-- 栏目 -->
            {% if ob.column %}
                <!-- 栏目column用不同方法表示 -->
                <button type="button"
                    class="btn btn-sm mb-2
                        {% if ob.column.title == '交友' %}
                            btn-success
                        {% elif ob.column.title == '学习' %}
                            btn-danger
                        {% elif ob.column.title == '生活' %}
                            btn-warning
                        {% endif %}
                    "
                >
                    {{ ob.column }}
                </button>
            {% endif %}
            <h4>
                <b>
                    <!-- 点击可以通过链接进入问题或文章的详细界面-->
                    {% if ob.type == 'question' %}
                    <a href="{% url 'question:question_detail' ob.id %}"
                       style="color: black;"
                    >
                        {{ ob.title }}
                    </a>
                    {% else %}
                    <a href="{% url 'article:article_detail' ob.id %}"
                       style="color: black;"
                    >
                        {{ ob.title }}
                    </a>
                    {% endif %}
                </b>
            </h4>
            <!-- 显示内容的摘要 -->
            <div>
                <p style="color: gray;">
                    {{ ob.body|slice:'100' }}...
                </p>
            </div>
            <!-- 注脚 -->
            <p>
                <!-- 附加信息 -->
                <span>
                    <i class="fas fa-clock" style="color:pink;"></i>
                    {{ ob.updated|date:'Y-m-d' }}
                </span>
                <span>
                    <i class="fa fa-battery-full" aria-hidden="true"></i>
                    {{ ob.type }}
                </span>
            </p>
        </div>
        <hr style="width: 100%;"/>

        {% endfor %}

    </div>
<!-- 
片段名称：  翻页
作者:	    ssc
时间：	    2020-8-2
功能：	    翻页功能，显示当前在的页数
            并可以通过链接到其他的页
修改记录： 
--> 
    <div class="pagination row">
        <div class="m-auto">
            <span class="step-links">
                <!-- 如果不是第一页，则显示上翻按钮 -->
                {% if column_content.has_previous %}
                    <a href="?page=1" class="btn btn-success">
                        &laquo; 1
                    </a>
                    <span>...</span>
                    <a href="?page={{ column_content.previous_page_number }}" class="btn btn-secondary">
                        {{ column_content.previous_page_number }}
                    </a>
                {% endif %}

                <!-- 当前页面 -->
                <span class="current btn btn-danger btn-lg">
                    {{ column_content.number }}
                </span>

                <!-- 如果不是最末页，则显示下翻按钮 -->
                {% if column_content.has_next %}
                    <a href="?page={{ column_content.next_page_number }}" class="btn btn-secondary">
                        {{ column_content.next_page_number }}
                    </a>
                    <span>...</span>
                    <a href="?page={{ column_content.paginator.num_pages }}"class="btn btn-success">
                        {{ column_content.paginator.num_pages }} &raquo;
                    </a>
                {% endif %}
            </span>
        </div>
    </div>

</div>

</div>
{% endblock content %}

templates/userprofile/sidebar.html
<div class="container-fluid">
	<div class="row ">
		<!--分成两份2-10-->
		<div class="col-md-2 col-sm-2">
			<!--第一个列，2/12，中间嵌套一个行，-->
			<div class="row">
				<div class="col-md-8 col-sm-8">
					<ul class="nav nav-sidebar">
						<li><button type="button" class="btn btn-light"><a href="{% url 'userprofile:profile_update' user.id %}">更改个人信息</a></button></li>
						<li><button type="button" class="btn btn-light"><a href="{% url 'userprofile:password_update' user.id %}">修改个人密码</a></button></li>
					</ul>
                </div>
            </div>   
		</div>
	</div>
</div>